package com.vk;
import java.util.*;
//import java.io.*;
import javax.mail.*;
import javax.mail.internet.*;
import javax.activation.*;
import com.vk.*;

public class emls{
  public emls() {
    int i; String txt,host,port,ssl,user,password,charset,subject,from,to,letter; 
    String[] tmp; Boolean debug = false;
    tmp = MyPro.split(MyPro.txt,'|');
    host = tmp[0]; port = tmp[1]; ssl = tmp[2]; user = tmp[3]; password = tmp[4];
    charset = tmp[5]; subject = tmp[6]; from = tmp[7]; to = tmp[8]; letter = tmp[9];
    Properties props = new Properties(); props.put("mail.smtp.host", host);
    props.put("mail.smtp.port", port); props.put("mail.smtp.auth", "true");
    if(ssl.equals("no")){props.put("mail.smtp.starttls.enable", "true");}
    else{props.put("mail.smtp.socketFactory.port", port); 
      props.put("mail.smtp.socketFactory.class", "javax.net.ssl.SSLSocketFactory");}
    props.put("mail.user", user); props.put("mail.password", password); props.put("mail.debug", debug);
    Authenticator auth = new SMTPAuth(user, password);
    Session session = Session.getInstance(props, auth); session.setDebug(debug); txt = null;
    try {
      MimeMessage msg = new MimeMessage(session);
      msg.setFrom(new InternetAddress(from));
      InternetAddress[] address = {new InternetAddress(to)};
      msg.setRecipients(Message.RecipientType.TO, address);
      msg.setSubject(subject); msg.setSentDate(new Date());
      msg.setText(letter, charset); Transport.send(msg);
    }catch (MessagingException mex){
      txt = "Exception handling in emls"+"\n"+mex.toString()+"\n";
      Exception ex = mex;
      do {
        if (ex instanceof SendFailedException) {
          SendFailedException sfex = (SendFailedException)ex;
          Address[] invalid = sfex.getInvalidAddresses();
          if (invalid != null){ txt += "    ** Invalid Addresses\n";
            for (i = 0; i < invalid.length; i++) txt += "         "+invalid[i]+"\n";
          }
          Address[] validUnsent = sfex.getValidUnsentAddresses();
          if (validUnsent != null){ txt += "    ** ValidUnsent Addresses\n";
            for (i = 0; i < validUnsent.length; i++) txt += "         "+validUnsent[i]+"\n";
          }
          Address[] validSent = sfex.getValidSentAddresses();
          if (validSent != null){ txt += "    ** ValidSent Addresses\n";
            for (i = 0; i < validSent.length; i++) txt += "         "+validSent[i]+"\n";
          }
        }
        txt += "\n";
        if (ex instanceof MessagingException) ex = ((MessagingException)ex).getNextException();
        else ex = null;
      } while (ex != null);
    }  MyPro.txt = txt;
  }  
}

class SMTPAuth extends javax.mail.Authenticator {
 private String userName; private String password;

 public SMTPAuth(String userName, String password) {
  this.userName = userName; this.password = password;
 }
 public PasswordAuthentication getPasswordAuthentication() {
  return new PasswordAuthentication(userName, password);
 }
}   

