package com.vk;
import com.vkm.*;

public class grFxy{
 double[][] xy = new double[2][65536];
 int nvs = 3000; double[][] vs = new double[2][nvs]; 
 double[][] pa = new double[2][100000];
 int[] ka = new int[100000];
 double[] d = new double[4];
 double[] c = new double[4];
 double[] vp = new double[4];
 double[] c1 = new double[4];
 double[] p = new double[4];
 double[] po = new double[4];
 double[] z;
 double[] za = new double[512];
 double[][] ct = new double[4][200];  
 int j,jct,nx,ny,ngv,kms,kml;
 int nxfm,nxsm,nyfm,nysm,nzfm,nzsm,nax; // c(18)
 double xmi,xma,xfm,xdm,ymi,yma,yfm,ydm,zmi,zma,zfm,zdm; // c() 6-9 10-13 14-17
 double hx,hy,dx,dy,dxy,dyx,zmax,ols;
 // 
 public grFxy(double[] zi, double[] pi, int[] n){
  int i,nn; double o; j=0;
  nx=n[0]; ny=n[1]; ngv=n[2]; kms=n[3]; kml=n[4]; 
  nxfm=n[5]; nxsm=n[6]; nyfm=n[7]; nysm=n[8]; nzfm=n[9]; nzsm=n[10]; nax=n[11];
  xmi=pi[0]; xma=pi[1]; xfm=pi[2]; xdm=pi[3];
  ymi=pi[4]; yma=pi[5]; yfm=pi[6]; ydm=pi[7];
  zmi=pi[8]; zma=pi[9]; zfm=pi[10]; zdm=pi[11];
  vp[0]=pi[12]; vp[1]=pi[13]; vp[2]=pi[14]; vp[3]=pi[15]; hx=pi[16]; hy=pi[17];
  dx=Math.abs(xma-xmi)*hx; dy=Math.abs(ymi-yma)*hy;
  o=Math.pow(dx*dx+dy*dy,0.5); dxy=o*kms/1000; dyx=o*kms/1000; ols=kml; ols/=kms;
  o=Math.pow(vp[0]/vp[1],0.25); dxy*=o; dyx/=o;
  zmax=zma-zmi; c[0]=0; c[1]=dx/(nx-1); c[2]=0; c[3]=dy/(ny-1);
  nn=nx*ny; z = new double[nn]; for(i=0; i<nn; i++){z[i]=zi[i]-zmi;}
  if( nn < 65537 ){ zxyvol(); axes(); }else{ mi.error(87); }
 }
 //
 private void zxyvol(){
  int i,kx,ky;
  for(i=0; i<4; i++){c1[i]=c[i];}
  c[0]=-dxy*ols; c[1]=dx+2*dxy*ols; c[2]=-dyx*ols; c[3]=dy+2*dyx*ols;
  za[0]=0; for(i=1; i<4; i++){za[i]=zmax;}
  zxypro(za,2,2,3,3); za[0]=0; za[1]=0;
  c[0]=c1[0]; c[1]=dx; c[2]=c1[2]; c[3]=dy;
  zxypro(za,2,1,1,1); zxypro(za,1,2,1,2);
  c[3]=0; za[2]=z[0]; za[3]=z[nx-1]; zxypro(za,2,2,4,2);
  c[2] += dy; za[1]=z[nx*(ny-1)]; zxypro(za,1,2,4,2);
  for(i=0; i<4; i++){c[i]=c1[i];}
  if(ngv == 1){for(ky=0; ky<ny; ky++){za[ky]=z[nx*ky];} zxypro(za,1,ny,1,2);}
  if(ngv == 2){zxypro(z,nx,1,1,1);}
  zxypro(z,nx,ny,1,ngv);
  if(ngv == 1){for(ky=0; ky<ny; ky++){za[ky]=z[nx*(ky+1)-1];} c[0] += dx; zxypro(za,1,ny,1,2);}
  if(ngv == 2){for(kx=0; kx<nx; kx++){za[kx]=z[kx+nx*(ny-1)];} c[2] += dy; zxypro(za,nx,1,1,1);}
 }
 //
 private void zxypro(double[] z, int nx, int ny, int ng2, int ng1){
  double x0,dx,y0,dy,h,x8,y8,x9,y9,o,v1,y,x,zt,h1,r,x1,y1;
  int i,is,is1,k,n1,n2;
  x8=d[0]; x9=d[1]; y8=d[2]; y9=d[3];
  x0=c[0]; dx=c[1]; y0=c[2]; dy=c[3]; h=Math.pow(10,vp[3]);
  if( ng2*(ng2-2)*(ng2-3) == 0 ){x8=1.e30; y8=x8; x9=-x8; y9=x9;}
  o=vp[0]*vp[0]+vp[1]*vp[1]+vp[2]*vp[2]; o=Math.pow(o,0.5); for(i=0; i<3; i++){vp[i] /= o;}
  o=vp[0]*vp[0]+vp[1]*vp[1]; v1=Math.pow(o,0.5); y=y0;
  for(n2=0; n2<ny; n2++){ x=x0;
   for(n1=0; n1<nx; n1++){ i=n1+n2*nx; zt=z[i]; h1=zt*vp[2]-y*vp[1]-x*vp[0];
    r=1/(v1*(1-h1/h)); x1=r*(x*vp[1]-y*vp[0]); y1=r*(zt-vp[2]*h1);
    if( ng2*(ng2-2)*(ng2-3) == 0 ){
     if(x8 > x1){x8=x1;} if(x9 < x1){x9=x1;} if(y8 > y1){y8=y1;} if(y9 < y1){y9=y1;} 
    } xy[0][n1+nx*n2]=x1; xy[1][n1+nx*n2]=y1; x += dx;
   } y += dy;
  }
  if( ng2*(ng2-3) == 0 ){for(k=0; k<nvs; k++){for(i=0; i<2; i++){vs[i][k]=2*y8-y9;}}}
  if( ng2 != 3 ){
   for(is=0; is<ny; is++){
    if( ng1 == 1 || ng1 == 3 ){
     if( nx > 1 ){
      for(is1=0; is1<(nx-1); is1++){
       for(k=0; k<2; k++){for(i=0; i<2; i++){p[i+2*k]=xy[i][k+is1+nx*is];}}
       fragmt(ng2);
    }}}
    if( ng1 == 2 || ng1 == 3 ){
     if( is < (ny-1) ){
      for(is1=0; is1<nx; is1++){
       for(k=0; k<2; k++){for(i=0; i<2; i++){p[i+2*k]=xy[i][is1+nx*(k+is)];}}
       fragmt(ng2);
  }}}}}
  d[0]=x8; d[1]=x9; d[2]=y8; d[3]=y9;
 }
 //
 private void fragmt(int ng2){
  double x0,x9,y0,y9,dx,dy,ey,h,v,r,x,y,y1,y2,s,s1,s2,s3;
  int i,j,m,ms,mf,md,ip; int[] mm = new int[2]; 
  x0=d[0]; x9=d[1]; y0=d[2]; y9=d[3];
  dx=x9-x0; dy=y9-y0; ey=1.e-4*dy;  
  h=dx/(nvs-1); ip=2;
  for(i=0; i<3; i+=2){po[i]=(p[i]-x0)/dx; po[i+1]=(p[i+1]-y0)/dy;}
  if( ng2 != 2 && ng2 != 5 ){
   for(i=0; i<2; i++){m=(int)Math.floor(1.5+(p[2*i]-x0)/h);
    if(m>nvs){m=nvs;} if(m<1){m=1;} m--; mm[i]=m;
   } md=mm[1]-mm[0];
   if( md != 0 ){v=(p[3]-p[1])/(h*md); r=p[1]-v*(x0+h*mm[0]);
    ms=Math.min(mm[0],mm[1]); mf=Math.max(mm[0],mm[1]); ip=0;
    for(m=ms; m<(mf+1); m++){x=x0+h*m; y=v*x+r; y1=y-vs[0][m]; y2=y-vs[1][m]; s=y1*y2;
     if(s < 0){i=0; if(Math.abs(y1/y2) > 1){i=1;}
      if(ip > 0){po[2]=(x-x0)/dx; po[3]=(vs[i][m]-y0)/dy; lines(); ip=0; continue;}
      ip=-1; po[0]=(x-x0)/dx; po[1]=(vs[i][m]-y0)/dy; continue;
     } ip++; if(ip == 0){ip=2;} j=0; if(ip > 1){j=2;} po[j]=(x-x0)/dx; po[j+1]=(y-y0)/dy;
     if(ng2 == 4){continue;}
     if(y1 >= 0){vs[1][m]=y-ey; if(vs[0][m] < y0){vs[0][m]=y+ey;} continue;
     } vs[0][m]=y+ey;
   }}else{m=mm[0]; i=3; if(p[1]>p[3]){i=1;} j=4-i; po[0]=h*m/dx; po[2]=po[0];
    s1=(p[i]-vs[1][m])*(p[i]-vs[0][m]); if(s1<0){po[i]=(vs[0][m]-y0)/dy;}
    s2=(p[j]-vs[1][m])*(p[j]-vs[0][m]); if(s2<0){po[j]=(vs[1][m]-y0)/dy;}
    ip=2; if(po[i]<po[j]){ip=0;} s3=(p[i]-vs[1][m])*(p[j]-vs[0][m]);
    if(s3<=0 && ip!=0){s1=po[j]; po[j]=(vs[1][m]-y0)/dy; lines();
     po[i]=(vs[0][m]-y0)/dy; po[j]=s1;
  }}} if(ip>=2){lines();}
 }
 //
 private void axes(){
  double x8,x9,y8,y9,dxs,dys,zt,o,o1,o2; int i,j,k,kb,m,nmx,nmy,nmz;
  x8=d[0]; x9=d[1]; y8=d[2]; y9=d[3]; jct=0;
  dxs=1/(x9-x8); dys=1/(y9-y8);
     // x short
  c[0]=Math.abs(xfm-xmi)*hx; c[1]=Math.abs(xdm)*hx; c[2]=-dyx; c[3]=dyx;
  nmx=(int)(Math.abs((xma-xfm)/xdm)+1); 
  for(i=0; i<(2*nmx); i++){za[i]=0;} zxypro(za,nmx,2,5,2);
     // y short
  c[0]=-dxy; c[1]=dxy; c[2]=Math.abs(yfm-ymi)*hy; c[3]=Math.abs(ydm)*hy;
  nmy=(int)(Math.abs((yma-yfm)/ydm)+1);
  if(nmy > nmx){for(i=(2*nmx); i<(2*nmy); i++){za[i]=0;}} zxypro(za,2,nmy,5,1);
     // x long
  o=xfm+xdm*(nxfm-1); o1=xdm*(nxsm+1); o2=dyx*ols;
  c[0]=Math.abs(o-xmi)*hx; c[1]=Math.abs(o1)*hx; c[2]=-o2; c[3]=o2;
  nmx=(int)(Math.abs((xma-o)/o1)+1); zxypro(za,nmx,2,5,2);
  for(i=0; i<nmx; i++){ct[0][jct]=(xy[0][i]-x8)*dxs;
   ct[1][jct]=(xy[1][i]-y8)*dys; ct[2][jct]=o; ct[3][jct]=1; jct++; o+=o1;}
     // y long
  o=yfm+ydm*(nyfm-1); o1=ydm*(nysm+1); o2=dxy*ols;
  c[0]=-o2; c[1]=o2; c[2]=Math.abs(o-ymi)*hy; c[3]=Math.abs(o1)*hy; 
  nmy=(int)(Math.abs((yma-o)/o1)+1); zxypro(za,2,nmy,5,1);
  for(i=0; i<nmy; i++){ct[0][jct]=(xy[0][2*i]-x8)*dxs;
   ct[1][jct]=(xy[1][2*i]-y8)*dys; ct[2][jct]=o; ct[3][jct]=2; jct++; o+=o1;}
     // z vertical
  za[1]=zmax; for(i=0; i<4; i++){c[i]=0;} c[2]=dy;
  if( nax == 0 || nax == 2 ){zxypro(za,1,2,5,2);}  c[0]=dx; c[2]=0;
  if( nax == 0 || nax == 1 ){zxypro(za,1,2,5,2);}  c[2]=dy;
  if( nax == 0 ){zxypro(za,1,2,4,2);}
     // z right short
  if( nax == 0 || nax == 1 ){
   nmz=(int)(Math.abs((zma-zfm)/zdm)+1);
   zt=zfm-zmi; for(i=0; i<nmz; i++){za[i]=zt; zt+=zdm;}
   for(k=0; k<nmz; k++){j=nmz-k-1; i=2*j; za[i+1]=za[j]; za[i]=za[j];}
   c[0]=dx; c[1]=dxy; c[2]=0; c[3]=0; zxypro(za,2,nmz,5,1);
     // z right long
   o=zfm+zdm*(nzfm-1); o1=zdm*(nzsm+1); o2=dxy*ols;
   nmz=(int)(Math.abs((zma-o)/o1)+1);
   zt=o-zmi; for(i=0; i<nmz; i++){za[i]=zt; zt+=o1;}
   for(k=0; k<nmz; k++){j=nmz-k-1; i=2*j; za[i+1]=za[j]; za[i]=za[j];}
   c[0]=dx; c[1]=o2; c[2]=0; c[3]=0; zxypro(za,2,nmz,5,1);
   for(i=0; i<nmz; i++){ct[0][jct]=(xy[0][1+2*i]-x8)*dxs;
    ct[1][jct]=(xy[1][1+2*i]-y8)*dys; ct[2][jct]=o; ct[3][jct]=3; jct++; o+=o1;}
   if( nax == 0 ){
    o=zfm+zdm*(nzfm-1); zt=o-zmi; for(i=0; i<nmz; i++){za[i]=zt; zt+=o1;}
    zt=o-zmi; for(i=0; i<nmz; i++){za[i]=zt; za[i+nmz]=zt; zt+=o1;}
    c[0]=dx; c[1]=0; c[2]=0; c[3]=dy; zxypro(za,nmz,2,4,2);
  }}
     // z left short
  if( nax == 0 || nax == 2 ){
   nmz=(int)(Math.abs((zma-zfm)/zdm)+1);
   zt=zfm-zmi; for(i=0; i<nmz; i++){za[i]=zt; za[i+nmz]=zt; zt+=zdm;}
   c[0]=0; c[1]=0; c[2]=dy; c[3]=dyx; zxypro(za,nmz,2,5,2); ;
     // z left long
   o=zfm+zdm*(nzfm-1); o1=zdm*(nzsm+1); o2=dyx*ols;
   nmz=(int)(Math.abs((zma-o)/o1)+1);
   zt=o-zmi; for(i=0; i<nmz; i++){za[i]=zt; za[i+nmz]=zt; zt+=o1;}
   c[0]=0; c[1]=0; c[2]=dy; c[3]=o2; zxypro(za,nmz,2,5,2); ;
   for(i=0; i<nmz; i++){ct[0][jct]=(xy[0][i+nmz]-x8)*dxs;
    ct[1][jct]=(xy[1][i+nmz]-y8)*dys; ct[2][jct]=o; ct[3][jct]=4; jct++; o+=o1;}
   if( nax == 0 ){
    o=zfm+zdm*(nzfm-1); zt=o-zmi; for(i=0; i<nmz; i++){za[i]=zt; zt+=o1;}
    for(k=0; k<nmz; k++){j=nmz-k-1; i=2*j; za[i+1]=za[j]; za[i]=za[j];}
    c[0]=0; c[1]=dx; c[2]=dy; c[3]=0; zxypro(za,2,nmz,4,1);
 }}}
 //
 private void lines(){
  if(j == 0){
   pa[0][j]=po[0]; pa[1][j]=po[1]; ka[j]=0; j++;
   pa[0][j]=po[2]; pa[1][j]=po[3]; ka[j]=1; j++;
  }else if(j < 99999){
   if(po[0] == pa[0][j-1] && po[1] == pa[1][j-1]){
    pa[0][j]=po[2]; pa[1][j]=po[3]; ka[j]=1; j++; 
   }else{
    pa[0][j]=po[0]; pa[1][j]=po[1]; ka[j]=0; j++;
    pa[0][j]=po[2]; pa[1][j]=po[3]; ka[j]=1; j++; 
 }}}
 //
 public int getN(){
  return j;
 }
 //
 public int getNT(){
  return jct;
 }
 //
 public double[][] getP(){
  return pa;
 }
 //
 public int[] getK(){
  return ka;
 }
 //
 public double[][] getT(){
  return ct;
 }
}
