package com.vku;

import com.vk.*;

public class linAlg{

 public static double vdot(double[] x, double[] y){
  int k,n; double s;
  n=x.length; s=0;
  for(k=0; k < n; k++){s=s+x[k]*y[k];}
  return s;
 } 

 public static double[] vecm(double[] a, double[] b){
  double[] c = new double[3];
  c[0]=a[1]*b[2]-b[1]*a[2]; c[1]=a[2]*b[0]-b[2]*a[0]; c[2]=a[0]*b[1]-b[0]*a[1];
  return c;
 }
 
 public static double[] vpas(double[] a){
  int k,n; n=a.length; double[] b = new double[n];
  for(k=0; k < n; k++){b[k]=a[k];}
  return b;
 }
 
 public static double[] vscale(double[] a, double c){
  int k,n; n=a.length; double[] b = new double[n];
  for(k=0; k < n; k++){b[k]=c*a[k];}
  return b;
 }

 public static double[] vunit(double[] a){
  int k,n; n=a.length; double[] b = new double[n]; double s;
  s=0; for(k=0; k < n; k++){s += a[k]*a[k];} s=1/Math.sqrt(s);
  for(k=0; k < n; k++){b[k]=s*a[k];}
  return b;
 }
  
 public static double[] mainv(double[] am){
  int i,j,k,m,na,n,nb,n0; double p; double[] b;
  int i1,i2,i3,i4,i5,i8,i9,l3,l4,l5,l6,l7,l8,n1,n2,n5,n6,n7,n8,n9,nc,o,r;
  double d,d1,p1,s1;
  na=am.length; p=na; n=(int)Math.round(Math.sqrt(p/2)); nb=3*na; nc=n;
  b = new double[nb]; double[] ami = new double[na]; n0=na/2;
  for(k=0; k < na; k++){ami[k]=0;}
  j=0; m=0;
  for(i=0; i < n; i++){
   for(k=0; k < n; k++){b[j]=am[m]; j++; m++;} m -= n; 
   for(k=0; k < n; k++){b[j]=am[m+n0]; j++; m++;}  
  } m=0;
  for(i=0; i < n; i++){
   for(k=0; k < n; k++){b[j]=-am[m+n0]; j++; m++;} m -= n; 
   for(k=0; k < n; k++){b[j]=am[m]; j++; m++;}  
  }
  for(i=0; i < n; i++){
   for(k=0; k < n; k++){b[j]=0; if(k == i){b[j]=1;} j++;}
   for(k=0; k < n; k++){b[j]=0; j++;}
  }
  n1=2*n; n2=n;
//begin slemg();
  i5=0; i8=0; l7=0;
  d1=1; n=n1; l3=n+n2; l4=n-1; l5=-n-1; 
  for(m=1; m <= l4; m++){
   p1=0; l5=l5+n+1; l6=l5-m+n;
   for(i1=l5; i1 <= l6; i1++){
    if(Math.abs(b[i1]) > Math.abs(p1)){p1=b[i1]; l7=i1;}
   } 
   if(p1 == 0){n9=-1; d=d1; System.out.println("  slemg fail on "+i8+" step"); return ami;}
   if(l7 != l5){d1=-d1; l7 -= n; i1=l5-n;
    for(i2=m; i2 <= l3; i2++){l7 += n; i1 += n; s1=b[i1]; b[i1]=b[l7]; b[l7]=s1;
   }}
   d1=d1*p1; p1=1/p1; i1=l5+1;
   for(i2=i1; i2 <= l6; i2++){b[i2] *= p1;}
   i3=l5; i9=m+1;
   for(i1=i9; i1 <= n; i1++){i3++; i4=l5; i5=i3;
    for(i2=i9; i2 <= l3; i2++){i4 += n; i5 += n; b[i5] -= b[i4]*b[i3];
  }}}
  d=d1; l8=i5-n*n2;
  if(b[l8] == 0){n9=-1; d=d1; System.out.println("  slemg fail on "+i8+" step"); return ami;}
  d *= b[l8]; n9=0; n0=n+1; n8=l4*n;
  for(i=n0; i <= l3; i++){n8=n8+n; n7=n8+n; n6=n*n; n5=n6+l4;
   for(i1=1; i1 <= l4; i1++){n7--; n6 -= n; n5 -= (n+1); b[n7] /= b[n5+1]; s1=b[n7]; i3=n8-1;
    for(i2=n6; i2 <= n5; i2++){i3++; b[i3] -= b[i2]*s1;
   }}
   b[n8] /= b[0];
  }
  i=-n-1; n8=l4*n; n7=n8+l4;
  for(i1=n0; i1 <= l3; i1++){n8 += n; n7 += n; i += n; i3=i;
   for(i2=n8; i2 <= n7; i2++){i3++; b[i3]=b[i2];
  }}
//end slemg();
  j=0; m=0; n0=na/2; n=nc;
  for(i=0; i < n; i++){
   for(k=0; k < n; k++){ami[m]=b[j]; j++; m++;} m -= n; 
   for(k=0; k < n; k++){ami[m+n0]=b[j]; j++; m++;}  
  }
  return ami;
 } 
  
 public static double[] macm(double[] a1, double[] a2, int nx, int nm, int ny){
  int j,j1,j2,k1,k2,km,m1,m2,m3,n; double s1,s2,h,h1,h2,h3;
  n=2*nx*ny; double[] res = new double[n]; m1=nx*nm; m2=nm*ny; m3=n/2;
  for(k2=0; k2 < ny; k2++){
   for(k1=0; k1 < nx; k1++){j=k1+k2*nx; s1=0; s2=0;
    for(km=0; km < nm; km++){j1=k1+km*nx; j2=km+k2*nm;
     h=a1[j1]; h1=a1[j1+m1]; h2=a2[j2]; h3=a2[j2+m2];
     s1=s1+h*h2-h1*h3; s2=s2+h*h3+h1*h2;
    } res[j]=s1; res[j+m3]=s2;
  }}
  return res;
 }

 public static double[] mdicom(double[] am){
  int n,na,ifail,i,ii,iii,i1,ien,iien,ien1,ie1,ie2,ie3,its,itn,iupp,iupp1,iupp11,o,o1,o2,o3;
  int j,jj,j1,l,la,low,low1,low11,k,k1,kk,m,mm,m1;
  double c,d,max,acheps,sum,term,sr,si,xr,xi,yr,yi,yyr,yyi,zr,zi,tr,ti,ahr,aahr,anorm;
  Complex cx,cy,cz;
  int[] intger; double[] wr,wi,res; double[][] ar,ai,vr,vi;
  boolean ok,ok1;

  na=am.length; d=na; n=(int)Math.round(Math.sqrt(d/2)); na=na+2*n;
  ar = new double[n][n]; ai = new double[n][n]; vr = new double[n][n]; vi = new double[n][n]; 
  intger = new int[n]; wr = new double[n]; wi = new double[n]; res = new double[na];
  j=0;
  for(i=0; i < n; i++){for(k=0; k < n; k++){ar[k][i]=am[j]; j++;}}
  for(i=0; i < n; i++){for(k=0; k < n; k++){ai[k][i]=am[j]; j++;}}
  for(i=0; i < na; i++){res[i]=0;} ifail=1;
// begin f01ame 
  k=1; l=n; la=l-1; k1=k+1; 
  if(k1 <= la){
   for(m=k1; m <= la; m++){o=m-1; 
    i=m; xr=0; xi=0; 
    for(j=m; j <= l; j++){o1=j-1; o2=o-1;
     if((Math.abs(ar[o1][o2])+Math.abs(ai[o1][o2])) > (Math.abs(xr)+Math.abs(xi))){xr=ar[o1][o2]; xi=ai[o1][o2]; i=j;}
    }
    intger[o]=i; o2=i-1;
    if(i != m){ m1=m-1;
     for(j=m1; j <= n; j++){o1=j-1; yr=ar[o2][o1]; ar[o2][o1]=ar[o][o1]; ar[o][o1]=yr; yi=ai[o2][o1]; ai[o2][o1]=ai[o][o1]; ai[o][o1]=yi;}
     for(j=1; j <= l; j++){o1=j-1; yr=ar[o1][o2]; ar[o1][o2]=ar[o1][o]; ar[o1][o]=yr; yi=ai[o1][o2]; ai[o1][o2]=ai[o1][o]; ai[o1][o]=yi;}
    } 
    if(xr != 0 || xi != 0){ m1=m+1;
     for(i=m1; i <= l; i++){o2=i-1; o3=o-1; yr=ar[o2][o3]; yi=ai[o2][o3];
      if(yr != 0 || yi != 0){cx = new Complex(xr,xi); cy = new Complex(yr,yi); cz=CMath.div(cy,cx); zr=cz.real(); zi=cz.imag();  //a02ace 
       yr=zr; yi=zi; ar[o2][o3]=yr; ai[o2][o3]=yi;
       for(j=m; j <= n; j++){o1=j-1; ar[o2][o1]=ar[o2][o1]-yr*ar[o][o1]+yi*ai[o][o1]; ai[o2][o1]=ai[o2][o1]-yr*ai[o][o1]-yi*ar[o][o1];}
       for(j=1; j <= l; j++){o1=j-1; ar[o1][o]=ar[o1][o]+yr*ar[o1][o2]-yi*ai[o1][o2]; ai[o1][o]=ai[o1][o]+yr*ai[o1][o2]+yi*ar[o1][o2];}
  }}}}} 
// end f01ame  
  acheps=1e-14;
// begin f02are
  low=1; iupp=n; tr=0; ti=0; itn=30*n;
  for(i=0; i < n; i++){for(j=0; j < n; j++){vr[i][j]=0; vi[i][j]=0;} vr[i][i]=1;}    
  iupp1=iupp-1; low1=low+1;
  if(low1 <= iupp1){
   for(ii=low1; ii <= iupp1; ii++){
    i=low1+iupp1-ii; o2=i-1; j=intger[o2]; o1=j-1; i1=i+1; 
    if(i1 <= iupp){for(k=i1; k <= iupp; k++){o3=i-2; o=k-1; vr[o][o2]=ar[o][o3]; vi[o][o2]=ai[o][o3];}}
    if(i != j){
     if(i <= iupp){
      for(k=i; k <= iupp; k++){o=k-1; vr[o2][o]=vr[o1][o]; vi[o2][o]=vi[o1][o]; vr[o1][o]=0; vi[o1][o]=0;}
     } vr[o1][o2]=1;
  }}} low11=low-1; 
  if(low11 > 0){
   for(i=1; i <= low11; i++){o=i-1; wr[o]=ar[o][o]; wi[o]=ai[o][o];}
  } iupp11=iupp+1;
  if(iupp11 <= n){
   for(i=iupp11; i <= n; i++){o=i-1; wr[o]=ar[o][o]; wi[o]=ai[o][o];}
  } 
//    ,  ,       
  ien=iupp;
  while(ien >= low){ its=0; ok=true; ie1=ien-1; ie2=ie1-1; ie3=ie2-1;
   while(ok){ ok1=true; k=-1; ahr=-1; aahr=-1;   
    if(low1 <= ien){
     for(kk=low1; kk <= ien; kk++){k=low1+ien-kk; k1=k-1; o=k-1; o1=k1-1; ahr=Math.abs(ar[o][o1])+Math.abs(ai[o][o1]);
      aahr=acheps*(Math.abs(ar[o1][o1])+Math.abs(ai[o1][o1])+Math.abs(ar[o][o])+Math.abs(ai[o][o]));
      if(ahr <= aahr){ok1=false; break;}
    }}
    if( ok1 ){k=low;}
    if(k == ien){break;}
    if(itn <= 0){return res;}
    if(its != 10 && its != 20){
     sr=ar[ie1][ie1]; si=ai[ie1][ie1];
     xr=ar[ie2][ie1]*ar[ie1][ie2]-ai[ie2][ie1]*ai[ie1][ie2];
     xi=ar[ie2][ie1]*ai[ie1][ie2]+ai[ie2][ie1]*ar[ie1][ie2];
     if(xr != 0 || xi != 0){
      yr=(ar[ie2][ie2]-sr)/2; yi=(ai[ie2][ie2]-si)/2;
      zr=xr+yr*yr-yi*yi; zi=xi+2*yr*yi; cz = new Complex(zr,zi); cz=CMath.pow(cz,0.5); zr=cz.real(); zi=cz.imag();   // a02aae   
      if((yr*zr+yi*zi) < 0){zr=-zr; zi=-zi;}
      yyr=yr+zr; yyi=yi+zi; 
      cx = new Complex(xr,xi); cy = new Complex(yyr,yyi); cz=CMath.div(cx,cy); xr=cz.real(); xi=cz.imag();
      sr=sr-xr; si=si-xi;
    }}
    else{sr=Math.abs(ar[ie1][ie2])+Math.abs(ar[ie2][ie3]); si=Math.abs(ai[ie1][ie2])+Math.abs(ai[ie2][ie3]);}
    if(low <= ien){
     for(i=low-1; i < ien; i++){ar[i][i]=ar[i][i]-sr; ai[i][i]=ai[i][i]-si;}
    }    
    tr=tr+sr; ti=ti+si; its=its+1; itn=itn-1; j=k+1;       
    xr=Math.abs(ar[ie2][ie2])+Math.abs(ai[ie2][ie2]);
    yr=Math.abs(ar[ie1][ie2])+Math.abs(ai[ie1][ie2]);
    zr=Math.abs(ar[ie1][ie1])+Math.abs(ai[ie1][ie1]); m=0; ok1=true;
    if(j <= ie1){
     for(mm=j; mm <= ie1; mm++){m=j+ie1-mm; yi=yr; m1=m-1; o=m-1; o1=m1-1; yr=Math.abs(ar[o][o1])+Math.abs(ai[o][o1]);
      xi=zr; zr=xr; xr=Math.abs(ar[o1][o1])+Math.abs(ai[o1][o1]);
      if(yr <= acheps*zr/yi*(zr+xr+xi)){ok1=false; break;}
    }}
    if( ok1 ){m=k;}  
    m1=m+1;
    if(m1 <= ien){
     for(i=m1; i <= ien; i++){
      i1=i-1; o=i-1; o1=i1-1; xr=ar[o1][o1]; xi=ai[o1][o1]; yr=ar[o][o1]; yi=ai[o][o1]; 
      if((Math.abs(xr)+Math.abs(xi)) >= (Math.abs(yr)+Math.abs(yi))){
       cx = new Complex(xr,xi); cy = new Complex(yr,yi); cz=CMath.div(cy,cx); zr=cz.real(); zi=cz.imag(); wr[o]=-1;}
      else{
       if(i1 <= n){
        for(j=i1; j <= n; j++){o2=j-1; zr=ar[o1][o2]; ar[o1][o2]=ar[o][o2]; ar[o][o2]=zr; zi=ai[o1][o2]; ai[o1][o2]=ai[o][o2]; ai[o][o2]=zi;
       }} 
       cx = new Complex(xr,xi); cy = new Complex(yr,yi); cz=CMath.div(cx,cy); zr=cz.real(); zi=cz.imag(); wr[o]=1;
      }
      ar[o][o1]=zr; ai[o][o1]=zi; 
      if(i <= n){
       for(j=i; j <= n; j++){o2=j-1; ar[o][o2]=ar[o][o2]-zr*ar[o1][o2]+zi*ai[o1][o2]; ai[o][o2]=ai[o][o2]-zr*ai[o1][o2]-zi*ar[o1][o2];}
     }}
     for(j=m1; j <= ien; j++){
      j1=j-1; o=j-1; o1=j1-1; xr=ar[o][o1]; xi=ai[o][o1]; ar[o][o1]=0; ai[o][o1]=0;
      if(wr[o] > 0){
       for(i=1; i <= j; i++){o2=i-1; zr=ar[o2][o1]; ar[o2][o1]=ar[o2][o]; ar[o2][o]=zr; zi=ai[o2][o1]; ai[o2][o1]=ai[o2][o]; ai[o2][o]=zi;}
       if(low <= iupp){
        for(i=low; i <= iupp; i++){o2=i-1; zr=vr[o2][o1]; vr[o2][o1]=vr[o2][o]; vr[o2][o]=zr; zi=vi[o2][o1]; vi[o2][o1]=vi[o2][o]; vi[o2][o]=zi;}
      }}  
      for(i=1; i <= j; i++){o2=i-1; ar[o2][o1]=ar[o2][o1]+xr*ar[o2][o]-xi*ai[o2][o]; ai[o2][o1]=ai[o2][o1]+xr*ai[o2][o]+xi*ar[o2][o];}  
      if(low <= iupp){
       for(i=low; i <= iupp; i++){o2=i-1; vr[o2][o1]=vr[o2][o1]+xr*vr[o2][o]-xi*vi[o2][o]; vi[o2][o1]=vi[o2][o1]+xr*vi[o2][o]+xi*vr[o2][o];}
   }}}}  
   wr[ie1]=ar[ie1][ie1]+tr; wi[ie1]=ai[ie1][ie1]+ti; ien=ien-1;
  }  
  anorm=0;
  for(i=1; i <= n; i++){o=i-1; anorm=anorm+Math.abs(wr[o])+Math.abs(wi[o]); i1=i+1;
   if(i1 <= n){for(j=i1; j <= n; j++){o1=j-1; anorm=anorm+Math.abs(ar[o][o1])+Math.abs(ai[o][o1]);}}
  } 
  if(anorm == 0){ifail=0; return res;}
  if(n >= 2){
   for(iien=2; iien <= n; iien++){
    ien=2+n-iien; ie1=ien-1; xr=wr[ie1]; xi=wi[ie1]; ien1=ien-1;
    if(ien1 >= 0){
     for(ii=1; ii <= ien1; ii++){  
      i=1+ien1-ii; o=i-1; zr=ar[o][ie1]; zi=ai[o][ie1]; i1=i+1;
      if(ien1 >= i1){
       for(j=i1; j <= ien1; j++){o1=j-1;
        zr=zr+ar[o][o1]*ar[o1][ie1]-ai[o][o1]*ai[o1][ie1];
        zi=zi+ar[o][o1]*ai[o1][ie1]+ai[o][o1]*ar[o1][ie1];
      }}
      yr=xr-wr[o]; yi=xi-wi[o];
      if(yr == 0 && yi == 0){yr=acheps*anorm;} 
      cz = new Complex(zr,zi); cy = new Complex(yr,yi); cx=CMath.div(cz,cy); ar[o][ie1]=cx.real(); ai[o][ie1]=cx.imag();
  }}}}
  low1=low-1;
  if(low1 > 0){
   for(i=1; i <= low1; i++){i1=i+1; o=i-1;
    if(i1 <= n){for(j=i1; j <= n; j++){o1=j-1; vr[o][o1]=ar[o][o1]; vi[o][o1]=ai[o][o1];}}
  }}
  iupp1=iupp+1;
  if(iupp1 <= n){
   for(i=iupp1; i <= n; i++){i1=i+1; o=i-1;
    if(i1 <= n){for(j=i1; j <= n; j++){o1=j-1; vr[o][o1]=ar[o1][o1]; vi[o1][o1]=ai[o][o1];}}
  }}
  if(low <= n){
   for(jj=low; jj <= n; jj++){ j=low+n-jj; o1=j-1;
    if(low <= iupp){
     for(i=low; i <= iupp; i++){o=i-1; zr=vr[o][o1]; zi=vi[o][o1];
      if(iupp >= j){m=j-1;}else{m=iupp;}
      if(low <= m){
       for(k=low; k <= m; k++){o2=k-1;
        zr=zr+vr[o][o2]*ar[o2][o1]-vi[o][o2]*ai[o2][o1]; zi=zi+vr[o][o2]*ai[o2][o1]+vi[o][o2]*ar[o2][o1];
      }}
      vr[o][o1]=zr; vi[o][o1]=zi;
  }}}} 
// end f02are
  for(i=0; i < n; i++){sum=0; max=0;
   for(j=0; j < n; j++){
    if(Math.abs(vr[j][i]) > max){max=Math.abs(vr[j][i]);}
    if(Math.abs(vi[j][i]) > max){max=Math.abs(vi[j][i]);}
   }
   for(j=0; j < n; j++){vr[j][i]=vr[j][i]/max; vi[j][i]=vi[j][i]/max;}
   max=0; c=0; d=0;
   for(j=0; j < n; j++){term=Math.pow(vr[j][i],2)+Math.pow(vi[j][i],2); sum=sum+term;
    if(term > max){max=term; c=vr[j][i]; d=-vi[j][i];}
   } 
   sum=sum*(c*c+d*d); sum=Math.sqrt(sum);
   for(j=0; j < n; j++){term=vr[j][i]; vr[j][i]=(vr[j][i]*c-vi[j][i]*d)/sum; vi[j][i]=(d*term+c*vi[j][i])/sum;}
  } j=0;       
  for(i=0; i < n; i++){res[j]=wr[i]; j++;} for(i=0; i < n; i++){res[j]=wi[i]; j++;}
  for(i=0; i < n; i++){for(k=0; k < n; k++){res[j]=vr[k][i]; j++;}}
  for(i=0; i < n; i++){for(k=0; k < n; k++){res[j]=vi[k][i]; j++;}}
  ifail=0; return res;
 } 
 
} 
   /*      .

      
      .    res = linalg.macm(a1,a2,nx,nm,ny);
    a1 -    2*nx*nm,     , 
     ,     , a2 -      
    2*nm*ny, res -    2*nx*ny,   , 
     a1  a2.
   
           
              res = linalg.mdicom(am);
    am -    2*n*n,     , 
     ,     
   res -    2*n*(1+n),    c ,
     ,      ,   
         Java.     
    NAG (subroutine f02ake)      .  
      .      .

         ami=linarg.mainv(am);
    am  ami -  ,    ,  ami -  
     am   .       slemg - 
       . */
