package com.vk;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;

public class AnimationFrame extends JDialog implements MouseListener, MouseMotionListener, KeyListener {
 int kx,ky,m,n,nx,ny,wf,hf,wi,hi,ifm; BufferedImage bi; 
 public int key,mod,cc,x1,y1,x2,y2;    

 public AnimationFrame(Frame own, String tit, int w, int h, int x, int y){
  super(own);
  setTitle(tit); setSize(w,h);
  if(x < 0 && y < 0){setLocationRelativeTo(null);}else{setLocation(x,y);} setModal(false);
  setResizable(false); wf=w; hf=h; n=-1; ifm=3;
  m=0; mod=0; key=0; x1=0; y1=0; x2=0; y2=0;
  addMouseListener(this); addMouseMotionListener(this); addKeyListener(this);
  addWindowListener(
   new WindowAdapter(){
    public void windowClosing(WindowEvent e){ MyPro.lobr=1; dispose();
  }});
  BufferedImage big = new BufferedImage(wf,hf,BufferedImage.TYPE_INT_RGB);
  Graphics gg = big.getGraphics(); gg.setColor(new Color(200,200,200)); gg.fillRect(0,0,wf,hf);
  MyPro.bi[0]=big; n=0; nx=0; ny=0; repaint();
  this.setVisible(true);
 }

 public void paint(Graphics g){
  if( (n+1)*(100-n) > 0 ){bi = MyPro.bi[n];}else{bi=null;}
  if( bi != null ){wi=bi.getWidth(); hi=bi.getHeight(); g.drawImage(bi,(wf-wi)/2+nx,(hf-hi)/2-ny,null);
 }}

 public void render(int nb, int x, int y){
  setTitle(MyPro.mtit); n=nb-1; nx=x; ny=y; repaint();  
 }

 public void close(){
  setVisible(false); MyPro.lobr=1; dispose();
 }

 public void keyTyped(KeyEvent e){}
 public void keyPressed(KeyEvent e){key=e.getKeyCode();}
 public void keyReleased(KeyEvent e){}

 public void mouseClicked(MouseEvent e){mod=e.getModifiers(); cc=e.getClickCount();} 
 public void mouseEntered(MouseEvent e){} 
 public void mouseExited(MouseEvent e){} 
 public void mousePressed(MouseEvent e){} 
 public void mouseReleased(MouseEvent e){} 

 public void mouseMoved(MouseEvent e) {
  kx=e.getX()-ifm; if(kx < 1){kx=1;} if(kx > wf){kx=wf;}
  ky=hf-e.getY()+ifm; if(ky < 1){ky=1;} if(ky > hf){ky=hf;}
  x1=kx; y1=ky;
 }

 public void mouseDragged(MouseEvent e) {
  kx=e.getX()-ifm; if(kx < 1){kx=1;} if(kx > wf){kx=wf;}
  ky=hf-e.getY()+ifm; if(ky < 1){ky=1;} if(ky > hf){ky=hf;}
  if(m == 0){m=1; x1=kx; y1=ky;}else{x2=kx; y2=ky;}
 }

}
