package com.vku;

import java.io.*;
import java.util.*;
import com.vk.*;

//program DILAC, written by Victor Kohn (modified 13/3/2, 27/6/4, 8/2/5, java 15/6/6, 14/7/7)

public class DilacPro{
 static String[] log = new String[50];
 static String mdir;
 public static boolean ok;
 static double[] x = new double[10001]; 
 static double[] fs = new double[4001];
 static double[] fex = new double[1001]; 
 //===============
 public static void exec(String mwdir) throws IOException {
  int i,i0,i1,i2,i3,i4,i1b,i2b,ii,il,ip,is,j,j1,k,kf,kfa,kg,kl,km,ko,kvar,kp,ks,nc,ncont,nex,nf,nfn,nfu,ng;
  int nh,nir,nl,nl1,nl2,nla,nli,nlog,nmod,nmode,nnorm,np,np1,np2,npf,npg,npm,nps,ntf,ntp,ns,nud,nv,nvar,nyt;
  double a1,a2,a3,ab,b,bm,c1,c2,c3,c4,c5,c6,c7,c2tb,cp,cpy,ctr,d1,dpar,ddpar,di,dl,dltot,dp,dpa,dpm,dpm2,dr;
  double dt,dw,dy,dym,em1,em2,em3,exl,exl0,exlm,f3,f9,f14,f20,fi,fit,fu,g0,g0m,gh,h,h1,h2,h3;
  double p,pa,par,pa1,pam,pbg,pe,pf,pit,pl,p1f,p1l,p2f,p2l,pp1,pp2,pp3,pp4,pp5,pp6,rf1,rf2,ri,rk,rm0,rma;
  double s,s1,s2,s1b,s2b,s2tb,sb,sbm,sfga,si2,tt,t1,t2,tb,tf,weight,wgc,wgt,wgt2,wl,xx,y,y0,y1,z,zn,zyi,zz;
  Complex ca,cb,cc,cd,ce,cr,cs,ct,cx1,cx2,cx3,cy;
  double[] f = new double[1101];  double[] tr = new double[101];
  double[] yi = new double[101];  double[] fa = new double[5];
  double[] fr = new double[3];  double[] fy = new double[3];  double[] dm = new double[6];  double[] fin;
  double[] fco = new double[8001];  double[] pm = new double[3];  
  double[] fmo = new double[1003];  double[] fga = new double[502];
  double[] dtl = {0.,0.157164,0.077323,0.053968,0.042843,0.036499,0.032562,0.030042,0.028333,0.027604,0.027325};
  String[] tmp = new String[30];  String line,ls,fne,fnad,fnrf; StringTokenizer t; String[] fnr = new String[4];
  BufferedReader ins,ins5,ins6; Forma frm;
  File fnsf,fn51,fn52,fn71,fn72; PrintWriter outsf,out10,out51,out52,out71,out72;
//
  il=0; weight=0;
  f3=0; f9=0; f14=0; f20=0; par=0; pbg=0; pe=0; pp1=0; pp2=0; pp3=0; pp4=0; pp5=0; pp6=0; s1=0; s2=0; wgc=0; y=0; z=0;
  ins5=null; out10=null; out52=null; out72=null; outsf=null; 
//
  log[1]="Program DILAC-java by Victor Kohn, created 15.6.6. from version 8.2.5";
  log[2]=" "; nlog=3; ncont=1; mdir=mwdir; File fni= new File(mwdir+"/dilac.par");
  if( !fni.exists() ){log[nlog]="Input data file is absent ..."; nlog++; wrlog(nlog,1); return;}
  ins = new BufferedReader(new FileReader(fni));
  while(ncont == 1){
   ls = ins.readLine(); t = new StringTokenizer(ls); nmode=Integer.parseInt(t.nextToken());
   nfn=Integer.parseInt(t.nextToken());
   ls = ins.readLine(); t = new StringTokenizer(ls); for(i=0; i < nfn; i++){fnr[i]=t.nextToken();}
   ls = ins.readLine(); t = new StringTokenizer(ls);
   pf=Double.parseDouble(t.nextToken()); pl=Double.parseDouble(t.nextToken()); np=Integer.parseInt(t.nextToken());
   ls = ins.readLine(); t = new StringTokenizer(ls);
   wl=Double.parseDouble(t.nextToken()); tb=Double.parseDouble(t.nextToken()); g0=Double.parseDouble(t.nextToken()); 
   gh=Double.parseDouble(t.nextToken()); exl0=Double.parseDouble(t.nextToken()); 
   ls = ins.readLine(); t = new StringTokenizer(ls);
   ntp=Integer.parseInt(t.nextToken()); ng=Integer.parseInt(t.nextToken()); ns=Integer.parseInt(t.nextToken());
   nf=Integer.parseInt(t.nextToken()); nud=Integer.parseInt(t.nextToken()); nyt=Integer.parseInt(t.nextToken());
   nps=Integer.parseInt(t.nextToken()); npm=Integer.parseInt(t.nextToken()); npg=Integer.parseInt(t.nextToken());
   nex=Integer.parseInt(t.nextToken()); nir=Integer.parseInt(t.nextToken()); ntf=Integer.parseInt(t.nextToken());
   ls = ins.readLine(); t = new StringTokenizer(ls);
   nl=Integer.parseInt(t.nextToken()); nmod=Integer.parseInt(t.nextToken());
   ncont=nmod/100; nmod=nmod-100*ncont; nnorm=(nex-1)/4; nex=nex-4*nnorm; nfu=(nf+1)/2;
   nc=nfu*ns; nli=nl;
   for(kl=1; kl <= nli; kl++){
    j=11*kl; i=j-10; ls = ins.readLine(); t = new StringTokenizer(ls);
    for(k=i; k <= j; k++){f[k]=Double.parseDouble(t.nextToken());} for(k=3; k<5; k++){f[i+k] *= 0.0001;}
   }
   if( ntp == 1 && npm > 1 ){
    ls = ins.readLine(); t = new StringTokenizer(ls);
    for(k=1; k <= 5; k++){dm[k]=Double.parseDouble(t.nextToken());} dm[2] *= 0.0001;
   }
   if( npg > 1 ){ls = ins.readLine(); t = new StringTokenizer(ls); wgc=Double.parseDouble(t.nextToken());}
   if( nex > 0 ){ls = ins.readLine(); t = new StringTokenizer(ls); fne=t.nextToken();
    weight=Double.parseDouble(t.nextToken()); File ffne = new File(mwdir+"/"+fne);
    if( !ffne.exists() ){log[nlog]="Experimental data file is absent ..."; nlog++; wrlog(nlog,1); return;}
    else{ 
     ins6 = new BufferedReader(new FileReader(ffne));
     for(i=1; i <= np; i++){j=i+np;
      ls = ins6.readLine(); t = new StringTokenizer(ls);
      if( (nex-1)*(nex-2) == 0 ){z=Double.parseDouble(t.nextToken()); fex[i]=Double.parseDouble(t.nextToken());}
      if( (nex-3) == 0 ){z=Double.parseDouble(t.nextToken()); fex[i]=Double.parseDouble(t.nextToken());
       fex[j]=Double.parseDouble(t.nextToken());}
      if( (nex-4) == 0 ){z=Double.parseDouble(t.nextToken()); fex[j]=Double.parseDouble(t.nextToken());
       fex[i]=Double.parseDouble(t.nextToken());}
     } ins6.close();
   }} 
   if( nmod == 1 ){
    ls = ins.readLine(); t = new StringTokenizer(ls); nla=Integer.parseInt(t.nextToken());
    ddpar=Double.parseDouble(t.nextToken()); nl1=nl+1; nl2=nl+nla; j=11*nl-10; f[j]=f[j]/(nla+1); dpar=f[11*nl-9];
    for(kl=nl1; kl <= nl2; kl++){
     for(j=1; j <=11; j++){i1=j+11*(kl-1); i2=j+11*(nl-1); f[i1]=f[i2];}
     j=11*kl-9; dpar += ddpar; f[j]=dpar;
    } nl=nl2;
   }
   if( nmod == 2 ){
    ls = ins.readLine(); t = new StringTokenizer(ls); dltot=Double.parseDouble(t.nextToken());
    for(j=12; j <= 22; j++){i=j+11*19; f[i]=f[j];}
    for(kl=2; kl <=20; kl++){
     for(j=1; j <=11; j++){
      j1=j+11*20; i=j+11*(kl-1);
      if( (j > 1 && j < 9) || j == 11 ){h=(f[j1]-f[j])/20; f[i]=f[j]+h*(kl-1);}
      if( j == 1 ){ if( kl < 12 ){f[i]=dtl[kl-1]*dltot;} if( kl > 11 ){f[i]=dtl[21-kl]*dltot;} }
      if( (j-9)*(j-10) == 0 ){ f[i]=f[j];
    }}}
    f[1]=f[1]-dltot/2; if(f[1] < 0){f[1]=0;} f[221]=f[221]-dltot/2; if(f[221] < 0){f[221]=0;}
    if(f[231] == 0){f[225]=0;} nl=21;
   }
   nvar=1;
   if( nmod >= 3 ){
    ls = ins.readLine(); t = new StringTokenizer(ls); nvar=Integer.parseInt(t.nextToken());
    fnad="addpar.txt"; fnrf="fitdata.txt";
    File ffnad = new File(mwdir+"/"+fnad);
    if( !ffnad.exists() ){log[nlog]="File addpar.txt is absent ..."; nlog++; wrlog(nlog,1); return;}
    else{ 
     ins5 = new BufferedReader(new FileReader(ffnad));
     File ffnrf = new File(mwdir+"/"+fnrf); out10 = new PrintWriter(new FileWriter(ffnrf));
     f3=f[3]; f9=f[9]; f14=f[14]; f20=f[20];
   }} if(ncont == 0){ins.close();}
//
/// ------------ gauss function
//
   if( npg > 1 ){
    if( wgc <= 0 ){log[nlog]="Width of Gaussian [Wgc] <= 0"; nlog++; wrlog(nlog,1); return;}
    else{ 
     if( nir > 0 ){fnsf = new File(mwdir+"/gauss.dep"); outsf = new PrintWriter(new FileWriter(fnsf));}
     wgt=2.5*wgc; h=(pl-pf)*(npg-1); np1=(int)Math.rint(h/wgt); wgt=h/np1; dpa=wgt/(npg-1);
     si2=wgt/5; wgt2=wgt/2; p1l=pl+wgt2; p1f=pf-wgt2; np1=(int)Math.rint((p1l-p1f)/dpa+1); pa1=-wgt2; sfga=0;
     for( k=1; k <= npg; k++){pa=pa1+dpa*(k-1); fga[k]=Math.exp(-Math.pow(pa/si2,2)); sfga=sfga+fga[k];}
     for( k=1; k <= npg; k++ ){pa=pa1+dpa*(k-1); fga[k]=fga[k]/sfga;
      if( nir > 0 ){frm = new Forma(pa,15,4); outsf.print(frm.getEStr());
       frm = new Forma(fga[k],15,5); outsf.println(frm.getEStr());}
      pa=pa+dpa;
     }
     if( nir > 0 ){outsf.close();
   }}}
   else{p1f=pf; p1l=pl; np1=np;}
   log[nlog]="Sample curve interval adding Gaussian"; nlog++;
   frm = new Forma(p1f,15,4); tmp[0]=frm.getEStr(); frm = new Forma(p1l,15,4); tmp[1]=frm.getEStr();
   frm = new Forma(np1,15,4); tmp[2]=frm.getEStr();
   log[nlog]=" p1f,p1l,np1 ="+tmp[0]+tmp[1]+tmp[2]; nlog++;
//
/// ------------  sample parameters
//
   if( ntp == 1 ){ pbg=10000; } if( ntp == 2 ){ pbg=100000; }
   tb=tb/57.2958; s2tb=Math.sin(2.*tb); c2tb=Math.cos(2.*tb); zn=3-2*ng; b=g0/gh;
   frm = new Forma(b,12,4); log[nlog] = "betta ="+frm.getStr(); nlog++;
   if( b <= 0 ){log[nlog] = "Input data are wrong: Betta-Sample <= 0"; nlog++; wrlog(nlog,1); return;}
   sb=Math.sqrt(b); zyi=3-2*nud; exl=exl0*g0/(sb*Math.sin(tb)); cpy=0.02*Math.PI*exl*Math.sin(tb)/gh;
   if( ntp == 1 ){ cpy=cpy*Math.cos(tb)/wl; }  if( ntp == 2 ){ cpy=cpy*Math.sin(tb)/12.3984; }
   frm = new Forma(cpy,15,5); log[nlog]=" cpy ="+frm.getEStr(); nlog++;
//
/// ------------------  monochromator
//
   if( ntp == 1 && npm > 1 ){
    dym=8; bm=dm[5];
    if( bm <= 0 ){log[nlog] = "Input data are wrong: Betta-Monochr. <= 0"; nlog++; wrlog(nlog,1); return;}
    else{
     if( nir > 0 ){fnsf = new File(mwdir+"/monoch.dep"); outsf = new PrintWriter(new FileWriter(fnsf));}
     sbm=Math.sqrt(bm); g0m=bm*s2tb/Math.sqrt(1.+bm*(bm+2.*c2tb)); exlm=exl0*g0m/(sbm*Math.sin(tb));
     y0=0.25*exlm*dm[2]*(1.+bm)/g0m; ca=new Complex(dm[1],-dm[1]*dm[3]); h=cpy*(p1l-p1f)*(npm-1)/(sb*sbm);
     np2=(int)Math.rint(h/dym); dym=h/np2; dy=dym/(npm-1); dpm=dym*sb*sbm/cpy; dpm2=dpm/2; p2f=p1f-dpm2;
     p2l=p1l+dpm2; np2=(int)Math.rint((p2l-p2f)*(npm-1)/dpm+1); y1=-dym/2;
     for( k=1; k <= npm; k++){y=y1+dy*(k-1); pam=y*sb*sbm/cpy; cc=ca;
      for( ks=1; ks <= ns; ks++){
       if(ks == 2){cc=CMath.mul(cc,c2tb);} cb = new Complex(-y,-y0); cs=CMath.mul(cb,cb); ct=CMath.mul(cc,cc);
       cs=CMath.sub(cs,ct); cs=CMath.pow(cs,0.5);
       if( cs.imag() < 0 ){cs=CMath.mul(cs,-1.);}
       cr=CMath.add(cb,cs); cr=CMath.div(cr,cc); xx=cr.abs2(); fr[ks]=xx*dm[4]*dm[4];
      }
      switch(ns){
       case 1: fmo[k]=fr[1];
        if(nir > 0){frm=new Forma(pam,12,3); outsf.print(frm.getEStr());
         frm=new Forma(fr[1],12,5); outsf.println(frm.getEStr());}
       break;
       case 2: fmo[k]=fr[1]; fmo[k+npm]=fr[2];
        if(nir > 0){frm=new Forma(pam,15,4); outsf.print(frm.getEStr()); frm=new Forma(fr[1],15,5);
         outsf.print(frm.getEStr()); frm=new Forma(fr[2],15,5); outsf.println(frm.getEStr());}
       break;
     }}
     if( nir > 0 ){outsf.close();
   }}}
   else{p2f=p1f; p2l=p1l; np2=np1;}
   log[nlog]="Sample curve interval adding Monochromator"; nlog++;
   frm = new Forma(p2f,15,4); tmp[0]=frm.getEStr(); frm = new Forma(p2l,15,4); tmp[1]=frm.getEStr();
   frm = new Forma(np2,15,4); tmp[2]=frm.getEStr();
   log[nlog]=" p2f,p2l,np2 ="+tmp[0]+tmp[1]+tmp[2]; nlog++;
   for( kvar=1; kvar <= nvar; kvar++){
// --------------------------- variants
    if( nmod == 3 ){
     ls = ins5.readLine(); t = new StringTokenizer(ls); pp1=Double.parseDouble(t.nextToken());
     pp2=Double.parseDouble(t.nextToken()); pp3=Double.parseDouble(t.nextToken());
     f[1]=pp1; f[2]=pp2; f[3]=f3*pp3; f[9]=f9*pp3;
    }        
    if( nmod == 4 ){
     ls = ins5.readLine(); t = new StringTokenizer(ls); pp1=Double.parseDouble(t.nextToken());
     pp2=Double.parseDouble(t.nextToken()); pp3=Double.parseDouble(t.nextToken());
     pp4=Double.parseDouble(t.nextToken()); pp5=Double.parseDouble(t.nextToken());
     pp6=Double.parseDouble(t.nextToken());
     f[1]=pp1; f[2]=pp2; f[3]=f3*pp3; f[9]=f9*pp3; f[12]=pp4; f[13]=pp5; f[14]=f14*pp6; f[20]=f20*pp6;
    }        
//
// ----------  sample curves (plane wave)
//
    if(nir > 0){fnsf = new File(mwdir+"/planew.dep"); outsf = new PrintWriter(new FileWriter(fnsf));}
    dp=(p2l-p2f)/(nps-1);
    for(kp=1; kp <= nps+2; kp++){
     if(kp == 1){y=cpy*pbg;} if(kp == 2){y=-cpy*pbg;}
     if(kp > 2){par=p2f+dp*(kp-3); y=cpy*par;} cp=1;
     for(ks=1; ks <= ns; ks++){
      if(ks == 2){cp=c2tb;} cr=new Complex(0,0); cy=new Complex(1,0);
      for(kl=1; kl <= nl; kl++){
       if(ng == 1){il=nl+1-kl;} if(ng == 2 ){il=kl;} i=11*(il-1); cr=CMath.mul(cr,cy);
       ab=f[i+7];                                        // 7 - abs(Y)
       fi=f[i+8];                                        // 8 - phase of Y
       p=f[i+6];                                         // 6 - p=-Xi/Xr
       rma=f[i+4]/g0;                                    // 4 - mu0/g0
       dl=f[i+1];                                        // 1 - d
       dw=f[i+3];                                        // 3 - sdw
       cy=new Complex(ab*Math.cos(fi),ab*Math.sin(fi));  // Y complex
       y0=zn*rma*exl*(1.+zn*b)/4;
       if(kp == 1 && ks == 1 ){ctr=rma-2.*dw*p/(exl*sb);
        if(ctr < 0){frm = new Forma(kl,14,4); log[nlog]="Input data are wrong for layer number "+frm.getEStr(); nlog++;
         log[nlog]=" ABSORPTION, mu0 < 2*DW*p*sin(tb)/exl0"; nlog++; wrlog(nlog,1); return;
       }}
       cc=new Complex(cp*dw,-p*cp*dw);
       cb=new Complex(-y+cpy*f[i+2],-y0);                // 2 - shift par
       cs=CMath.mul(cb,cb); ct=CMath.mul(cc,cc); ct=CMath.mul(ct,zn); cs=CMath.sub(cs,ct); cs=CMath.pow(cs,0.5);
       if(cs.imag() < 0 ){cs=CMath.mul(cs,-1.);}
       ct=CMath.add(cb,cs); ct=CMath.div(ct,cc); cx1=CMath.mul(ct,-zn);
       ct=CMath.sub(cb,cs); ct=CMath.div(ct,cc); cx2=CMath.mul(ct,-zn);
       cr=CMath.div(cr,cy); cx3=CMath.sub(cx1,cr); ct=CMath.sub(cx2,cr); cx3=CMath.div(cx3,ct); 
       ct=new Complex(0,2*dl/exl); cs=CMath.mul(cs,ct); ct=new Complex(0,cs.imag()); cb=CMath.exp(ct);
       em3=expo(cs.real()); ce=CMath.mul(cb,em3); ca=CMath.sub(cx2,cx1);
       cd=CMath.sub(cr,cx1); cd=CMath.mul(cd,cs); ct=CMath.mul(cs,-1.); cd=CMath.mul(cd,cdexpo(ct,ce));
       cr=CMath.mul(ca,cr); ct=CMath.mul(cx2,cd); cr=CMath.add(cr,ct); ct=CMath.add(ca,cd); cr=CMath.div(cr,ct);
       if(nf > 1){
        if(ng == 1){cx3=CMath.mul(cx3,ce); ce=CMath.conjg(cb); ce=CMath.mul(ce,1./em3);}
        ca=new Complex(1.,0.); ca=CMath.sub(ca,cx3); zz=ca.abs2();
        ca=new Complex(1.,0.); ct=CMath.mul(cx3,ce); ca=CMath.sub(ca,ct); s=ca.abs2();
        rm0=rma*(1.-zn*b)/2.+f[i+5]*zyi;                   // 5 - mu-yi
        z=rm0*dl-zn*cs.real(); em1=expo(-z); tr[il]=em1*s/zz;
        if( nyt == 1 ){
         rk=f[i+11]*dl/zz;                                 // 11 - chi[i0]-at
         if(rk > 0){ dr=b*ab*ab;
          ab=2.*cp*sb*ab*f[i+9];                           // 9 - f[coh]
          fi=fi+f[i+10];                                   // 10 - phi[coh]
          cc=new Complex(ab*Math.cos(fi),ab*Math.sin(fi)); a1=cx1.abs2();
          ct=CMath.mul(cx1,cc); h1=(1.+ct.real()+a1*dr)*dexpo(z,em1);
          zz=rm0*dl+zn*cs.real(); em2=expo(-zz); a2=cx2.abs2(); a3=cx3.abs2();
          ct=CMath.mul(cx2,cc); h2=a3*(1.+ct.real()+a2*dr)*dexpo(zz,em2);
          cx1=CMath.conjg(cx1); cs=CMath.mul(cs,zn); cs=CMath.add(cs,z);
          ca=CMath.mul(cx1,cx2); ca=CMath.mul(ca,dr); ca=CMath.add(ca,1.); ca=CMath.mul(ca,2.);
          ct=CMath.conjg(cc); ct=CMath.mul(ct,cx1); ca=CMath.add(ca,ct); ct=CMath.mul(cc,cx2);
          ca=CMath.add(ca,ct); ca=CMath.mul(ca,cx3); ct=CMath.mul(ce,em1); ca=CMath.mul(ca,cdexpo(cs,ct));
          h3=ca.real(); yi[il]=rk*(h1+h2-h3);
         }else{yi[il]=0;}
      }}}
      s=1.;
      if(nf > 1){pe=0; z=1; s=0;
       for(kl=1; kl <= nl; kl++){s=s+z*yi[kl]; z=z*tr[kl]; i=11*(kl-1); pe=pe+f[i+1]*f[i+5]*zyi;}
       if(kp == 1 && ks == 1 && Math.abs(pe) > 85 ){
        log[nlog]=" Input data are wrong: YIELD DEPTH.  Sum (d/Dyi) > 85"; nlog++; wrlog(nlog,1); return;
      }}
      rf2=s; if(nyt != 1){rf2=z*Math.exp(pe);} cr=CMath.mul(cr,cy); rf1=cr.abs2();
      if(ng == 2){rf1=rf1*z*Math.exp(pe);}
      if(kp == 1 ){fa[2*ks-1]=rf1; fa[2*ks]=rf2;}
      if(kp == 2 ){i0=2*ks-1; fa[i0]=(fa[i0]+rf1)/2.; i0++; fa[i0]=(fa[i0]+rf2)/2.;
       frm=new Forma(rf1,15,5); tmp[0]=frm.getEStr();
       frm=new Forma(rf2,15,5); tmp[1]=frm.getEStr(); log[nlog]=" f_bg ="+tmp[0]+tmp[1]; nlog++;
      }
      else{fr[ks]=rf1; fy[ks]=rf2; if(nyt == 1){fy[ks]=rf2/fa[2*ks];}
     }}
     if(kp > 2){i=kp-2; i1=i+nps; i2=i1+nps; i3=i2+nps; nv=10*ns+nf;
      switch(nv){
       case 11: fs[i]=fr[1]; break;
       case 12: fs[i]=fy[1]; break;
       case 13: fs[i]=fy[1]; fs[i1]=fr[1]; break;
       case 21: fs[i]=fr[1]; fs[i1]=fr[2]; break;
       case 22: fs[i]=fy[1]; fs[i1]=fy[2]; break;
       case 23: fs[i]=fy[1]; fs[i1]=fr[1]; fs[i2]=fy[2]; fs[i3]=fr[2]; break;
      }
      if(nir > 0){
       if(nc == 1){frm=new Forma(par,15,5); tmp[0]=frm.getEStr(); frm=new Forma(fs[i],15,5); tmp[1]=frm.getEStr();
        outsf.println(tmp[0]+tmp[1]);}
       if(nc == 2){frm=new Forma(par,15,5); tmp[0]=frm.getEStr(); frm=new Forma(fs[i],15,5); tmp[1]=frm.getEStr();
        frm=new Forma(fs[i1],15,5); tmp[1]=frm.getEStr(); outsf.println(tmp[0]+tmp[1]);}
       if(nc == 4){frm=new Forma(par,15,5); tmp[0]=frm.getEStr(); frm=new Forma(fs[i],15,5); tmp[1]=frm.getEStr();
        frm=new Forma(fs[i1],15,5); tmp[2]=frm.getEStr(); frm=new Forma(fs[i2],15,5); tmp[3]=frm.getEStr();
        frm=new Forma(fs[i3],15,5); outsf.println(tmp[0]+tmp[1]+tmp[2]+tmp[3]+frm.getEStr()); 
    }}}}
    if(nir > 0){outsf.close();}
    i=1; i1=i+nps; i2=i1+nps; i3=i2+nps; i4=i3+nps; x[1]=cpy*p2f; h=cpy*(p2l-p2f)/(nps-1);
    for(kp=3; kp <= nps+1; kp++){i=kp-1; x[i]=x[1]+h*(i-1);}
    fin = spline(nps,np2,nc);
    if(nir == 10){
     fnsf = new File(mwdir+"/spline.dep"); outsf = new PrintWriter(new FileWriter(fnsf)); dp=(p2l-p2f)/(np2-1);
     for(i=1; i <= np2; i++){
      par=p2f+dp*(i-1); i1=i+np2; i2=i1+np2; i3=i2+np2;
      if(nc == 1){frm=new Forma(par,15,5); tmp[0]=frm.getEStr(); frm=new Forma(fin[i],15,5); tmp[1]=frm.getEStr();
       outsf.println(tmp[0]+tmp[1]);}
      if(nc == 2){frm=new Forma(par,15,5); tmp[0]=frm.getEStr(); frm=new Forma(fin[i],15,5); tmp[1]=frm.getEStr();
       frm=new Forma(fin[i1],15,5); tmp[1]=frm.getEStr(); outsf.println(tmp[0]+tmp[1]);}
      if(nc == 4){frm=new Forma(par,15,5); tmp[0]=frm.getEStr(); frm=new Forma(fin[i],15,5); tmp[1]=frm.getEStr();
       frm=new Forma(fin[i1],15,5); tmp[2]=frm.getEStr(); frm=new Forma(fin[i2],15,5); tmp[3]=frm.getEStr();
       frm=new Forma(fin[i3],15,5); outsf.println(tmp[0]+tmp[1]+tmp[2]+tmp[3]+frm.getEStr()); 
     }} outsf.close();
    }
    npf=np1*nfu; for(k=1; k <= npf; k++){fco[k]=0;}
//
/// -------- npm convolution
//
    if(ntp == 1){pit=0;
     for(ks=1; ks <= ns; ks++){
      if(npm > 1){i=npm*(ks-1); pm[ks]=0; for(k=1; k <= npm; k++){pm[ks] += fmo[i+k];}}
      else{pm[ks]=2.-ks+(ks-1.)*Math.cos(2.*tb);}
      pit += pm[ks];
     }
     for(ks=1; ks <= ns; ks++){
      if(npm == 1){i=npf*(ks-1); for(kp=1; kp <= npf; kp++){fco[kp] += fin[i+kp]*pm[ks];}}
      else{nh=(npm-1)/2; ip=npm*(ks-1); t1=cpy*p2f; t2=cpy*p2l; d1=(np2-1)/(t2-t1);
       dt=cpy*(p1l-p1f)/(np1-1); tf=cpy*p1f;
       for(kf=1; kf <= nfu; kf++){
        i0=np2*(kf-1+nfu*(ks-1)); kfa=nfu*(ks-1)+kf; i1b=0; i2b=0; s1b=0.; s2b=0.;
        for(ko=1; ko <= np1; ko++){tt=tf+dt*(ko-1); ri=(tt-t1)*d1; ii=(int)Math.floor(ri); di=ri-ii; i1=ii-nh+1;
         if(i1 < 1){i1=1;} if((i1+npm) > np2){i1=np2-npm; di=1.;} i2=i1+1;
         if(i1 == i1b){s1=s1b;} if(i1 == i2b){s1=s2b;}
         if(i1 != i1b && i1 != i2b){s1=0.; is=i0+i1; for(km=1; km <= npm; km++){s1 += fmo[ip+km]*fin[is+km];}}
         if(i2 == i1b){s2=s1b;} if(i2 == i2b){s2=s2b;}
         if(i2 != i1b && i2 != i2b){s2=0.; is=i0+i2; for(km=1; km <= npm; km++){s2 += fmo[ip+km]*fin[is+km];}}
         s=s1*(1.-di)+s2*di; i=np1*(kf-1)+ko; fco[i] += s; i1b=i1; s1b=s1; i2b=i2; s2b=s2;
     }}}}
     s=1./pit; for(k=1; k <= npf; k++){fco[k]*=s;}
    }
    else{
     for(ks=1; ks <= ns; ks++){i=npf*(ks-1); for(kp=1; kp <= npf; kp++){fco[kp] += fin[i+kp];}}
     for(k=1; k <= npf; k++){fco[k] /= ns;}
    }
//
// ----------  Gauss convolution
//
    dp=(pl-pf)/(np-1);
    if(npg > 1){d1=(np1-1)/(p1l-p1f); nh=(npg-1)/2;
     for(kf=1; kf <= nfu; kf++){i0=np1*(kf-1); i1b=0; i2b=0; s1b=0.; s2b=0.;
      for(ko=1; ko <= np; ko++){tt=pf+dp*(ko-1); ri=(tt-p1f)*d1; ii=(int)Math.floor(ri);
       di=ri-ii; i1=ii-nh+1; if(i1 < 1){i1=1;} if((i1+npg) > np1){i1=np1-npg; di=1.;}
       i2=i1+1; if(i1 == i1b){s1=s1b;} if(i1 == i2b){s1=s2b;}
       if(i1 != i1b && i1 != i2b){s1=0.; is=i0+i1; for(kg=1; kg <= npg; kg++){s1 += fga[kg]*fco[is+kg];}}
       if(i2 == i1b){s2=s1b;} if(i2 == i2b){s2=s2b;}
       if(i2 != i1b && i2 != i2b){s2=0.; is=i0+i2; for(kg=1; kg <= npg; kg++){s2 += fga[kg]*fco[is+kg];}}
       s=s1*(1.-di)+s2*di; i=np*(kf-1)+ko; fs[i]=s; i1b=i1; s1b=s1; i2b=i2; s2b=s2;
    }}}
    else{for(k=1; k <= npf; k++){fs[k]=fco[k];}}
//
// ---------- saving theoretical curves
//
    if(kvar == nvar){
     fn51 = new File(mwdir+"/"+fnr[0]); out51 = new PrintWriter(new FileWriter(fn51));
     if(nfu == 2){j=nmode; fn52 = new File(mwdir+"/"+fnr[j]); out52 = new PrintWriter(new FileWriter(fn52));}
     p=pf;
     for(ko=1; ko <= np; ko++){fu=fs[ko]; if(ntf >= 1 && nf >= 2){fu=fu-1;}
      frm=new Forma(p,15,5); tmp[0]=frm.getEStr(); frm=new Forma(fu,15,5); tmp[1]=frm.getEStr();
      out51.println(tmp[0]+tmp[1]); 
      if(nfu == 2){fu=fs[ko+np];  if(ntf > 1 && nf > 2){fu=fu*ntf;}
       frm=new Forma(p,15,5); tmp[0]=frm.getEStr(); frm=new Forma(fu,15,5); tmp[1]=frm.getEStr();
       out52.println(tmp[0]+tmp[1]); 
      } p=p+dp;
     } out51.close(); if(nfu == 2) out52.close();
    } 
//
// ----------  fit to experiment
//
    fit=0.; ok=false; if(nex >= 3 && nf == 3){ok=true;}
    if(nex > 0){
     c1=vdot(1,1,1,np); c6=vdot(1,2,1,np); c7=vdot(2,2,1,np); c2=c6/c7; if(nnorm == 1){c2=1;} c3=0;
     for(kp=1; kp <= np; kp++){fex[kp]=c2*fex[kp]; c3=c3+Math.pow(fs[kp]-fex[kp],2);}
     c3=c3/c1; fit=c3; frm=new Forma(c2,15,5); tmp[0]=frm.getEStr();
     frm=new Forma(c3,15,5); tmp[1]=frm.getEStr(); log[nlog]=" C1_norm, Fit = "+tmp[0]+tmp[1]; nlog++;
     if( ok ){i=1+np; c1=vdot(1,1,i,np); c6=vdot(1,2,i,np); c7=vdot(2,2,i,np); c2=c6/c7;
      if(nnorm == 1){c2=1;} c4=0.;
      for(kp=1; kp <= np; kp++){i=kp+np; fex[i]=c2*fex[i]; c4=c4+Math.pow(fs[i]-fex[i],2);}
      c4=c4/c1; c5=c3*(1.-weight)+c4*weight; fit=c5; frm=new Forma(c2,15,5); tmp[0]=frm.getEStr();
      frm=new Forma(c5,15,5); tmp[1]=frm.getEStr(); log[nlog]=" C2_norm, Fit = "+tmp[0]+tmp[1]; nlog++;
     }
     if(kvar == nvar){
      fn71 = new File(mwdir+"/"+fnr[1]); out71 = new PrintWriter(new FileWriter(fn71));
      if( ok ){fn72 = new File(mwdir+"/"+fnr[3]); out72 = new PrintWriter(new FileWriter(fn72));}
      p=pf;
      for(ko=1; ko <= np; ko++){ if(ntf == 1 && nex >= 2){fex[ko]=fex[ko]-1.;}
       frm=new Forma(p,15,5); tmp[0]=frm.getEStr(); frm=new Forma(fex[ko],15,5);
       tmp[1]=frm.getEStr(); out71.println(tmp[0]+tmp[1]); 
       if( ok ){k=ko+np; frm=new Forma(p,15,5); tmp[0]=frm.getEStr();
        frm=new Forma(fex[k],15,5); tmp[1]=frm.getEStr(); out72.println(tmp[0]+tmp[1]); 
       } p=p+dp;
      } out71.close(); if( ok ){out72.close();}
    }} 
// -----------------   variants
    if(nmod == 3){
     frm=new Forma(pp1,15,5); tmp[0]=frm.getEStr(); frm=new Forma(pp2,15,5); tmp[1]=frm.getEStr();
     frm=new Forma(pp3,15,5); tmp[2]=frm.getEStr(); frm=new Forma(fit,15,5); tmp[3]=frm.getEStr();
     out10.println(tmp[0]+tmp[1]+tmp[2]+tmp[3]);
    }
    if(nmod == 4){
     frm=new Forma(pp1,15,5); tmp[0]=frm.getEStr(); frm=new Forma(pp2,15,5); tmp[1]=frm.getEStr();
     frm=new Forma(pp3,15,5); tmp[2]=frm.getEStr(); frm=new Forma(pp4,15,5); tmp[3]=frm.getEStr();
     frm=new Forma(pp5,15,5); tmp[4]=frm.getEStr(); frm=new Forma(pp6,15,5); tmp[5]=frm.getEStr();
     frm=new Forma(fit,15,5); tmp[6]=frm.getEStr();
     out10.println(tmp[0]+tmp[1]+tmp[2]+tmp[3]+tmp[4]+tmp[5]+tmp[6]);
    }
//-----------------   variants end
   } if(nmod == 3){ins5.close(); out10.close();}	       
//  -------------   multiple calculating end
  } ins.close(); log[nlog]="end"; nlog++; wrlog(nlog,0);
 }   
 //
 private static void wrlog(int nlog, int nend){
  int k,nl; nl=0;
  switch(nend){
   case 0: ok=true; nl=nlog; break;
   case 1: ok=false; log[nlog]="Fatal error was detected. Computing impossible."; nl=nlog+1; break;
  } log[nl]=" "; nl++;
  try{
   File fn = new File(mdir+"/dilac.log");
   PrintWriter out = new PrintWriter(new FileWriter(fn));
   for(k=1; k < nl; k++){out.println(log[k]);} out.close(); 
  }catch(IOException ex){ex.printStackTrace();}
 }
 //
 private static double vdot(int n1, int n2, int i, int n){
  int k; double s,u,y; s=0; u=0; y=0;
  for(k=i; k < (i+n); k++){
   switch(n1){case 1: u=fs[k]; break; case 2: u=fex[k]; break;}
   switch(n2){case 1: y=fs[k]; break; case 2: y=fex[k]; break;}
   s=s+u*y;
  }
  return s;
 }
 //
 private static double expo(double z){
  double u; u=z;
  if(u < -100.) u=-100.;
  if(u >  100.) u=100.;
  return Math.exp(u);
 }
 //
 private static double dexpo(double z, double ez){
  double f;
  if(z < 0.01){f=1.-0.5*z*(1.-z/3.);}
  else{f=(1.-ez)/z;}
  return f;
 }
 //
 private static Complex cdexpo(Complex cz, Complex cez){
  Complex cf; double acz;
  acz=cz.abs();
  if(acz < 0.01){cf=CMath.mul(cz,1./3.); cf=CMath.neg(cf); cf=CMath.add(cf,1.); cf=CMath.mul(cf,cz);
   cf=CMath.mul(cf,0.5); cf=CMath.neg(cf); cf=CMath.add(cf,1.);}
  else{cf=CMath.neg(cez); cf=CMath.add(cf,1.); cf=CMath.div(cf,cz);}
  return cf;
 }
 //
 private static double[] spline(int n1, int n, int n2){
  int l,l1,l2,n3,n4,np,nd; np=n1+1; nd=n*n2+101; n3=n1-1; n4=n-1;
  double a,r1,d1,d2;  double[] x1,x2,x3,x4;
  x1 = new double[np]; x2 = new double[np]; x3 = new double[np]; x4 = new double[np]; 
  double[] y1 = new double[nd];
  if(n1 < 2){y1=null; return y1;}
  for(l2=0; l2 < n2; l2++){
   if(n1 > 2){
    x4[1]=x[2]-x[1]; x2[1]=-x4[1]; x3[1]=0; x3[2]=(fs[2+n1*l2]-fs[1+n1*l2])/x4[1];
    for(l=2; l <= n3; l++){x4[l]=x[l+1]-x[l]; x2[l]=2.*(x4[l-1]+x4[l]);
     x3[l+1]=(fs[l+1+n1*l2]-fs[l+n1*l2])/x4[l]; x3[l]=x3[l+1]-x3[l];
    }
    x2[n1]=-x4[n1-1]; x3[n1]=0;
    if(n1 > 3){a=(x3[3]/(x[4]-x[2])-x3[2]/(x[3]-x[1])); x3[1]=a*Math.pow(x4[1],2)/(x[4]-x[1]);
     r1=x3[n1-1]/(x[n1]-x[n1-2])-x3[n1-2]/(x[n1-1]-x[n1-3]); x3[n1]=-r1*Math.pow(x4[n1-1],2)/(x[n1]-x[n1-3]);
     for(l=2; l <= n1; l++){r1=x4[l-1]/x2[l-1]; x2[l]=x2[l]-r1*x4[l-1]; x3[l]=x3[l]-r1*x3[l-1];}
     x3[n1]=x3[n1]/x2[n1];
     for(l1=1; l1 <= n3; l1++){l=n1-l1; x3[l]=(x3[l]-x4[l]*x3[l+1])/x2[l];}
    }
    a=(fs[n1+n1*l2]-fs[n3+n1*l2])/x4[n3]; x2[n1]=a+x4[n3]*(x3[n3]+2.*x3[n1]);
    for(l=1; l <= n3; l++){a=(fs[l+1+n1*l2]-fs[l+n1*l2])/x4[l]; x2[l]=a-x4[l]*(x3[l+1]+2.*x3[l]);
     x4[l]=(x3[l+1]-x3[l])/x4[l]; x3[l]=x3[l]*3; x1[l]=fs[l+n1*l2];
    }
    x3[n1]=3.*x3[n1]; x4[n1]=x4[n1-1]; x1[n1]=fs[n1+n1*l2];
   }
   else{
    x2[1]=(fs[2+n1*l2]-fs[1+n1*l2])/(x[2]-x[1]); x3[1]=0; x4[1]=0;
    x1[1]=fs[1+n1*l2]; x2[2]=x2[1]; x3[2]=0; x4[2]=0; x1[2]=fs[2+n1*l2];
   }
   d1=(x[n1]-x[1])/n4; l=1; r1=x[1]; y1[1+n*l2]=x1[1];
   for(l1=2; l1 <= n4; l1++){r1=r1+d1;
    while( r1-x[l+1] >= 0 && l < n3 ){l=l+1;}
    d2=r1-x[l]; y1[l1+n*l2]=x1[l]+d2*(x2[l]+d2*(x3[l]+d2*x4[l]));
   }
   y1[n+n*l2]=x1[n1];
  } for(l=nd-100; l < nd; l++){y1[l]=0;}
  return y1;
 }
}

